<?php







	/*-- Custom Post Init Begin --*/







	function custom_product()







	{







	$labels = array(







		'name' => 'Products', 'post type general name',







		'singular_name' => 'Product', 'post type singular name',







		'add_new' => 'Add New', 'product',







		'add_new_item' => 'Add New Product',







		'edit_item' => 'Edit Product',







		'new_item' => 'New Product',







		'view_item' => 'View Product',







		'search_items' => 'Search Products',







		'not_found' =>  'No products found',







		'not_found_in_trash' => 'No products found in Trash',







		'parent_item_colon' => '',







		'menu_name' => 'Products'







	);















	$args = array(







		'labels' => $labels,







		'public' => true,







		'publicly_queryable' => true,







		'show_ui' => true,







		'show_in_menu' => true,







		'query_var' => true,







		'rewrite' => true,







		'capability_type' => 'post',







		'has_archive' => false,







		'hierarchical' => false,







		'menu_position' => null,







		'supports' => array('title','editor','author','thumbnail','excerpt'),







		'taxonomies' => array('post_tag') 







	);







	// The following is the main step where we register the post.







	register_post_type('product',$args);







	flush_rewrite_rules();







	}







	add_action('init', 'custom_product');  



	



	/*-- Custom Post Init Ends --*/















	/* Meta box setup function. */







	function mybook_post_meta_boxes_setup() {











		/* Add meta boxes on the 'add_meta_boxes' hook. */







		add_action( 'add_meta_boxes', 'mybook_add_post_meta_boxes' );







		







		/* Save post meta on the 'save_post' hook. */







		add_action( 'save_post', 'mybook_save_purchase_meta', 10, 2 );







	}







	/* Fire our meta box setup function on the post editor screen. */







	add_action( 'load-post.php', 'mybook_post_meta_boxes_setup' );







	add_action( 'load-post-new.php', 'mybook_post_meta_boxes_setup' );	







	/* Create one or more meta boxes to be displayed on the post editor screen. */







	function mybook_add_post_meta_boxes() {











		add_meta_box('mybook_amazon_link', 'Amazon Purchase Link', 'mybook_amazon_meta_box', 'product', 'side', 'default');







		add_meta_box('mybook_kobo_link', 'Kobo Purchase Link', 'mybook_kobo_meta_box', 'product', 'side', 'default');







		add_meta_box('mybook_bn_link' ,'Barnes & Noble Purchase Link' ,'mybook_bn_meta_box' ,'product' ,'side' ,'default');



		



		add_meta_box('mybook_amazon_uk_link' ,'Amazon UK Purchase Link' ,'mybook_amazon_uk_meta_box' ,'product' ,'side' ,'default');	



		



		add_meta_box('mybook_download_link' ,'Download Link' ,'mybook_download_meta_box' ,'product' ,'side' ,'default');







	}







	







	/* Display the post meta box. */







	function mybook_amazon_meta_box( $object, $box ) { ?>







		<?php wp_nonce_field( basename( __FILE__ ), 'mybook_amazon_nonce' ); ?>







		<p>Leave this area blank if your product is not available on Amazon.</p>







		<input class="widefat" type="text" name="mybook_amazon_link" id="mybook_amazon_link" placeholder="http://" value="<?php echo esc_attr( get_post_meta( $object->ID, 'mybook_amazon_link', true ) ); ?>" size="30" />







	<?php }















	/* Display the post meta box. */







	function mybook_kobo_meta_box( $object, $box ) { ?>







		<?php wp_nonce_field( basename( __FILE__ ), 'mybook_kobo_nonce' ); ?>







		<p>Leave this area blank if your product is not available on Kobo.</p>







		<input class="widefat" type="text" name="mybook_kobo_link" id="mybook_kobo_link" placeholder="http://" value="<?php echo esc_attr( get_post_meta( $object->ID, 'mybook_kobo_link', true ) ); ?>" size="30" />







	<?php }















	/* Display the post meta box. */







	function mybook_bn_meta_box( $object, $box ) { ?>







		<?php wp_nonce_field( basename( __FILE__ ), 'mybook_bn_nonce' ); ?>







		<p>Leave this area blank if your product is not available on Barnes & Noble.</p>







		<input class="widefat" type="text" name="mybook_bn_link" id="mybook_bn_link" placeholder="http://" value="<?php echo esc_attr( get_post_meta( $object->ID, 'mybook_bn_link', true ) ); ?>" size="30" />







	<?php }







	



	/* Display the post meta box. */







	function mybook_amazon_uk_meta_box( $object, $box ) { ?>







		<?php wp_nonce_field( basename( __FILE__ ), 'mybook_amazon_uk_nonce' ); ?>







		<p>Leave this area blank if your product is not available on Amazon UK.</p>







			<input class="widefat" type="text" name="mybook_amazon_uk_link" id="mybook_amazon_uk_link" placeholder="http://" value="<?php echo esc_attr( get_post_meta( $object->ID, 'mybook_amazon_uk_link', true ) ); ?>" size="30" />







	<?php }







	



	/* Display the post meta box. */







	function mybook_download_meta_box( $object, $box ) { ?>







		<?php wp_nonce_field( basename( __FILE__ ), 'mybook_download_nonce' ); ?>







		<p>Leave this area blank if your product is not available to download.</p>







		<input class="widefat" type="text" name="mybook_download_link" id="mybook_download_link" placeholder="http://" value="<?php echo esc_attr( get_post_meta( $object->ID, 'mybook_download_link', true ) ); ?>" size="30" />







	<?php }	



		



		



		



	/* Save the meta box's post metadata. */







	function mybook_save_purchase_meta( $post_id, $post ) {















		/* Verify the nonce before proceeding. */







		if ( !isset( $_POST['mybook_amazon_nonce'] ) || !wp_verify_nonce( $_POST['mybook_amazon_nonce'], basename( __FILE__ ) ) )







			return $post_id;















		/* Get the post type object. */







		$post_type = get_post_type_object( $post->post_type );















		/* Check if the current user has permission to edit the post. */







		if ( !current_user_can( $post_type->cap->edit_post, $post_id ) )







			return $post_id;















		/* Get the posted data and sanitize it for use as an HTML class. */







		$new_amazon_meta_value = ( isset( $_POST['mybook_amazon_link'] ) ? esc_url_raw( $_POST['mybook_amazon_link'] ) : '' );



		



		$new_amazon_uk_meta_value = ( isset( $_POST['mybook_amazon_uk_link'] ) ? esc_url_raw( $_POST['mybook_amazon_uk_link'] ) : '' );







		$new_kobo_meta_value = ( isset( $_POST['mybook_kobo_link'] ) ? esc_url_raw( $_POST['mybook_kobo_link'] ) : '' );







		$new_bn_meta_value = ( isset( $_POST['mybook_bn_link'] ) ? esc_url_raw( $_POST['mybook_bn_link'] ) : '' );



		



		$new_download_meta_value = ( isset( $_POST['mybook_download_link'] ) ? esc_url_raw( $_POST['mybook_download_link'] ) : '' );















		/* Get the meta key. */







		$amazon_meta_key = 'mybook_amazon_link';



	



		$amazon_uk_meta_key = 'mybook_amazon_uk_link';







		$kobo_meta_key = 'mybook_kobo_link';







		$bn_meta_key = 'mybook_bn_link';



		



		$download_meta_key = 'mybook_download_link';















		/* Get the meta value of the custom field key. */







		$amazon_meta_value = get_post_meta( $post_id, $amazon_meta_key, true );



		



		$amazon_uk_meta_value = get_post_meta( $post_id, $amazon_uk_meta_key, true );







		$kobo_meta_value = get_post_meta( $post_id, $kobo_meta_key, true );







		$bn_meta_value = get_post_meta( $post_id, $bn_meta_key, true );



		



		$download_meta_value = get_post_meta( $post_id, $download_meta_key, true );















		/* If a new meta value was added and there was no previous value, add it. */







		if ( $new_amazon_meta_value && '' == $amazon_meta_value )







			add_post_meta( $post_id, $amazon_meta_key, $new_amazon_meta_value, true );



		



		



		



		if ( $new_amazon_uk_meta_value && '' == $amazon_uk_meta_value )







			add_post_meta( $post_id, $amazon_uk_meta_key, $new_amazon_uk_meta_value, true );







			







		if ( $new_kobo_meta_value && '' == $kobo_meta_value )







			add_post_meta( $post_id, $kobo_meta_key, $new_kobo_meta_value, true );















		if ( $new_bn_meta_value && '' == $bn_meta_value )







			add_post_meta( $post_id, $bn_meta_key, $new_bn_meta_value, true );		







			



		if ( $new_download_meta_value && '' == $download_meta_value )







			add_post_meta( $post_id, $download_meta_key, $new_download_meta_value, true );		















		/* If the new meta value does not match the old value, update it. */







		elseif ( $new_amazon_meta_value && $new_amazon_meta_value != $amazon_meta_value )







			update_post_meta( $post_id, $amazon_meta_key, $new_amazon_meta_value );	



			



			



		elseif ( $new_amazon_uk_meta_value && $new_amazon_uk_meta_value != $amazon_uk_meta_value )







			update_post_meta( $post_id, $amazon_uk_meta_key, $new_amazon_uk_meta_value );







		







		elseif ( $new_kobo_meta_value && $new_kobo_meta_value != $kobo_meta_value )







			update_post_meta( $post_id, $kobo_meta_key, $new_kobo_meta_value );	







			







		elseif ( $new_bn_meta_value && $new_bn_meta_value != $bn_meta_value )







			update_post_meta( $post_id, $bn_meta_key, $new_bn_meta_value );	



			



		



		elseif ( $new_download_meta_value && $new_download_meta_value != $download_meta_value )







			update_post_meta( $post_id, $download_meta_key, $new_download_meta_value );















		/* If there is no new meta value but an old value exists, delete it. */







		elseif ( '' == $new_amazon_meta_value && $amazon_meta_value )







			delete_post_meta( $post_id, $amazon_meta_key, $amazon_meta_value );







			



		elseif ( '' == $new_amazon_uk_meta_value && $amazon_uk_meta_value )







			delete_post_meta( $post_id, $amazon_uk_meta_key, $amazon_uk_meta_value );







			







		elseif ( '' == $new_kobo_meta_value && $kobo_meta_value )







			delete_post_meta( $post_id, $kobo_meta_key, $kobo_meta_value );







			







		elseif ( '' == $new_bn_meta_value && $bn_meta_value )







			delete_post_meta( $post_id, $bn_meta_key, $bn_meta_value );



			



		



		elseif ( '' == $new_download_meta_value && $download_meta_value )







			delete_post_meta( $post_id, $download_meta_key, $download_meta_value );







	}







?>